class NodoFin(object):
    __slots__ = ["comienzo"]
    def __init__(self, comienzo):
        self.comienzo = comienzo

class FrickyTrie(object):
    def __init__(self, palabras):
        self.data = self._llena(sorted(set(palabras)))

    def _llena(self, pals):
        d = {}
        if "" in pals:
            d[None] = None
            pals.remove("")

        ant = pals[0][0]
        restos = [pals[0][1:]]
        masdeuno = False
        for pal in pals[1:]:
            prim,rest = pal[0],pal[1:]
            if prim == ant:
                restos.append(rest)
                masdeuno = True
                continue

            if masdeuno:
                d[ant] = self._llena(restos)
            else:
                d[ant] = restos[0]
            ant = prim
            restos = [rest]
            masdeuno = False

        if masdeuno:
            d[ant] = self._llena(restos)
        else:
            d[ant] = restos[0]
        return d

    def get(self, busq):
        self._result = []

        try:
            parcial = []
            dic = self.data
            for car in busq:
                if isinstance(dic, str):
                    r = "".join(parcial)+dic
                    if len(r) < len(busq):
                        return []
                    return [r]
                parcial.append(car)
                dic = dic[car]
            if isinstance(dic, str):
                return ["".join(parcial)+dic]
        except KeyError:
            return []
        
        self._result = []
        self._arma(dic, busq)
        return self._result
            
    def _arma(self, dic, base):
        if None in dic:
            self._result.append(base)
            del dic[None]
        for k,v in dic.items():
            if isinstance(v, str):
                self._result.append(base+k+v)
            else:
                self._arma(v, base+k)
                
            

if __name__ == "__main__":
    import time, random, os
    
    ini = time.time()
    palabras = [p[:-2] for p in open("diccionario.txt")]
    ft = FrickyTrie(palabras)
    print "En cargar: %.2f seg" % (time.time()-ini)

    def control(kb, pals):
#        ft = FrickyTrie(pals)
        res = ft.get(kb)
        dif = set(res) ^ set(pals)
        if dif:
            print kb, "MAL!!!!!!!!!!!"
            print "--", dif
        else:
            print kb, "ok!"

    control("salada", ['desaladamente', 'ensalada', 'salada', 'saladamente', 'saladar'])
    control("auxi", ['auxiliador', 'auxiliar', 'auxiliar\xeda', 'auxilio', 'auxina', 'bauxita'])
    control("hombre",  ["gentilhombre", "hombre", "hombrear", "hombrecillo", "hombredad", "hombrera", "milhombres", "prohombre", "ricohombre", "semihombre", "superhombre", "tragahombres"])

    pid = os.getpid()
    os.system("top -b -n1 -p %d" % pid)

    CANT = 5000
    palabras = [p[:-2] for p in open("diccionario.txt") if len(p)>7]
    palabras = [random.choice(palabras)[:5] for x in xrange(CANT)]

    ini = time.time()
    for p in palabras:
        ft.get(p)
    print "Busq x palabra: %.3f mseg" % (1000 * (time.time()-ini) / CANT)



